d3.csv('https://gist.githubusercontent.com/codingcooper/350a662b384d585be60ac9234461369b/raw/e72a9ca9c679cd00ecdd11f2d0261dc60880c7a6/penguins.csv', function(err, rows){
function unpack(rows, key) {
	return rows.map(function(row)
	{ return row[key]; });}
  var colors = []
  var i = 0
    for (i=0; i < unpack(rows, 'Species').length; i++) {
      if (unpack(rows, 'Species')[i] == "Adelie Penguin (Pygoscelis adeliae)") {
        colors.push(0)
      } else if (unpack(rows, 'Species')[i] == "Chinstrap penguin (Pygoscelis antarctica)") {
        colors.push(0.5)
      } else if (unpack(rows, 'Species')[i] == "Gentoo penguin (Pygoscelis papua)") {
        colors.push(1)
      }
    }

    var pl_colorscale=[
               [0.0, '#4682b4'],
               [0.333, '#4682b4'],
               [0.333, '#fe8a71'],
               [0.666, '#fe8a71'],
               [0.666, '#f6cd61'],
               [1, '#f6cd61']
    ]
var trace1 = {
	x:unpack(rows, 'BodyMass'), 
  y:unpack(rows, 'CulmenLength'), 
  z:unpack(rows, 'FlipperLength'),
	mode: 'markers',
      marker: {
        color: colors,
        colorscale:pl_colorscale,
        size: 12,
        line: {
          color: 'white',
          width: 0.5
        }
      },
	type: 'scatter3d'
};


var data = [trace1];
var layout = {margin: {
	l: 0,
	r: 0,
	b: 0,
	t: 0
  },
	scene: {
		xaxis:{title: 'BodyMass', 
  backgroundcolor: "rgb(105, 20, 92, 0.1)",
	 gridcolor: "rgb(255, 255, 255)",
	 showbackground: true,
	 zerolinecolor: "rgb(255, 255, 255)"},
		yaxis:{title: 'CulmenLength',
     backgroundcolor: "rgb(200, 200,200)",
     gridcolor: "rgb(255, 255, 255)",
     showbackground: true,
     zerolinecolor: "rgb(255, 255, 255)"},
		zaxis:{title: 'FlipperLength',
     backgroundcolor: "rgb(230, 230,230)",
     gridcolor: "rgb(255, 255, 255)",
     showbackground: true,
     zerolinecolor: "rgb(255, 255, 255)"},
		}        
  };
Plotly.newPlot('myDiv', data, layout);
});
